# -*- coding:utf8 -*-


class Config(object):

    def __init__(self,
                 path,
                 embedding_size=200,
                 hidden_size=100,
                 batch_size=32,
                 class_size=5,
                 keep_prob=0.5,
                 voc_size=0,
                 char_voc_size=65,
                 max_word_length=10,
                 char_embed_size=50,
                 word_attention_loss_lambda=0.001,  # CE: 0.001
                 sent_attention_loss_lambda=0.05    # CE: 0.05
                 ):
        self._voc_path = path
        self._embedding_size = embedding_size
        self._hidden_size = hidden_size
        self._batch_size = batch_size
        self._class_size = class_size
        self._keep_prob = keep_prob
        self._voc_size = voc_size
        self._char_voc_size = char_voc_size
        self._max_word_length = max_word_length
        self._char_embed_size = char_embed_size
        self._word_attention_loss_lambda = word_attention_loss_lambda
        self._sent_attention_loss_lambda = sent_attention_loss_lambda

    @property
    def voc_path(self):
        return self._voc_path

    @property
    def embedding_size(self):
        return self._embedding_size

    @property
    def hidden_size(self):
        return self._hidden_size

    @property
    def batch_size(self):
        return self._batch_size

    @property
    def class_size(self):
        return self._class_size

    @property
    def keep_prob(self):
        return self._keep_prob

    @property
    def voc_size(self):
        return self._voc_size

    @property
    def char_voc_size(self):
        return self._char_voc_size

    @property
    def max_word_length(self):
        return self._max_word_length

    @property
    def char_embed_size(self):
        return self._char_embed_size

    @property
    def word_attention_loss_lambda(self):
        return self._word_attention_loss_lambda

    @property
    def sent_attention_loss_lambda(self):
        return self._sent_attention_loss_lambda
